/// <reference types="node" />
/**
 * Handles attaching session
 */
import Session = require('msgpack5rpc');
import { ILogger } from '../utils/logger';
import { VimValue } from '../types/VimValue';
import { Neovim } from './Neovim';
export declare class NeovimClient extends Neovim {
    protected requestQueue: Array<any>;
    private _sessionAttached;
    private _channel_id;
    constructor(options?: {
        session?: Session;
        logger?: ILogger;
    });
    attachSession({reader, writer}: {
        reader: NodeJS.ReadableStream;
        writer: NodeJS.WritableStream;
    }): void;
    readonly isApiReady: boolean;
    readonly channelId: Promise<number>;
    handleRequest(method: string, args: VimValue[], resp: any, ...restArgs: any[]): void;
    handleNotification(method: string, args: VimValue[], ...restArgs: any[]): void;
    startSession(): void;
    requestApi(): Promise<any[]>;
    generateApi(): Promise<null | boolean>;
}
